/*******************************************************************
  uLan Communication - basic library

  ul_l_log.c	- simple logging support

  (C) Copyright 2002 by Pavel Pisa 

  The uLan driver is distributed under the Gnu General Public Licence. 
  See file COPYING for details.
 *******************************************************************/

//#ifndef _MSC_VER
//#include <unistd.h>
//#endif /*_MSC_VER*/
#include <stdlib.h>
//#include <fcntl.h>
#include <stdio.h>
#include <sys/types.h>
//#include <sys/time.h>
//#include <sys/stat.h>
//#include <string.h>
#include <stdarg.h>
#include <ul_lib/ulan.h>

void
ul_log_fnc_default(const char *domain, int level,
	const char *format, va_list args);

ul_log_fnc_t *ul_log_output;
FILE *ul_log_default_file;

void
ul_log(const char *domain, int level,
       const char *format, ...)
{
  va_list ap;
  if(ul_log_output==NULL) {
    char *log_fname;
    ul_log_output=ul_log_fnc_default;
    if((log_fname=getenv("UL_LOG_FILENAME"))!=NULL){
      ul_log_default_file=fopen(log_fname,"a");
    }
    if(ul_log_default_file==NULL)
      ul_log_default_file=stderr;
  }
  va_start(ap, format);
  (*ul_log_output)(domain,level,format,ap);
  va_end(ap);
}

void
ul_log_redir(ul_log_fnc_t *log_fnc, int add_flags)
{
  if(log_fnc==NULL) log_fnc=ul_log_fnc_default;
  ul_log_output=log_fnc;
}

void
ul_log_fnc_default(const char *domain, int level,
	const char *format, va_list ap)
{
  if(!(level&UL_LOGL_CONT)) {
    level&=UL_LOGL_MASK;
    if(!domain) domain="unknown";
    if(level)
      fprintf(ul_log_default_file,"<%d>%s: ",level,domain);
    else
      fprintf(ul_log_default_file,"%s: ",domain);
  }
  vfprintf(ul_log_default_file,format, ap);
  fflush(ul_log_default_file);
}

